# Configurazione dei server di Ubuntu-it

Questo repository contiene la configurazione dei server di Ubuntu-it. La
configurazione è gestita interamente con Ansible.

## Deploy della configurazione

Per effettuare il deploy di alcuni cambiamenti alla configurazione del server,
bisogna modificarla e poi lanciare lo script di deploy:

```
$ ./deploy <ambiente> <playbook>
```

L'ambiente per la macchina di produzione è `prod`, ed è possibile crearne uno
locale. Il playbook è il nome del playbook di ansible che si vuole eseguire
sull'ambiente. Per esempio, per eseguire il playbook `main.yml` in produzione è
necessario digitare il comando:

```
$ ./deploy prod main
```

Potrebbe esser necessario decriptare alcuni file nel repository prima di
eseguire il deploy: vedere la sezione "Ansible Vault" più in basso per maggiori
dettagli.

## Creazione di ambienti locali

È possibile creare ambienti locali, la cui configurazione non è salvata nel
repository git: questi ambienti sono utili per esempio se si vuole provare le
modifiche su un server in locale.

Gli ambienti locali sono identificati dal nome col suffisso `.local`, ma
possono essere usati nel comando senza il suffisso (per esempio, l'ambiente
`dev.local` può essere chiamato come `dev`). Inoltre, è possibile sovrascrivere
ambienti esistenti creando ambienti locali con lo stesso nome.

## Ansible Vault

In questo repository sono salvati dei valori segreti, criptati con Ansible
Vault, ed è necessario decriptarli per poter eseguire alcuni playbook. È
possibile farlo in due modi:

* Puoi inserire la password di Ansible Vault ogni volta che viene richiesta

* Puoi creare uno script eseguibile chiamato `vault-password`, che prende la
  password dal tuo password manager (o equivalente) e la mostra a schermo: lo
  script verrà chiamato da Ansible in background per ottenere la password

Lo script eseguibile è motlo comodo perché permette di non scrivere la password
ogni volta. Un esempio di script è il seguente:

```bash
#!/bin/bash
pass -c git/uit/ubuntu-it-sistemisti/servers-config/ansible-vault | head -n 1
```

È possibile creare nuovi file criptati e modificarli con il comando
`ansible-vault`.
